/* $Id: macdep_sh3.h,v 1.4 2002/01/13 13:26:31 amura Exp $ */
/*
 *  Copyright (c) 2001,2002    MURAMATSU Atsushi
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * A Simple Monitor Program Header
 *   - machine dependent macros for HITACHI SH-3
 */

#ifndef __MACDEP_H__
#define __MACDEP_H__

#include "7709a.h"		/* this header is provided by HITACHI */

/***** feature select *****/
#define FAR			/* far address indicator */
#define HAVE_RTSCTS		/* have serial RTS/CTS control lines */
/* #undef HAVE_SLINE_INTR */	/* have serial line change interrupt */
#define HAVE_SLINE_AUTO		/* have automatic RTS/CTS line handling */
#define HAVE_SUB_SRAM		/* have sub SRAM for backup */
/* #undef HAVE_CPU_BREAK */	/* CPU support hardware break point */
#define SERIAL_INTR_LEVEL	7

/***** constans for SRAM *****/
#ifdef HAVE_SUB_SRAM
#define DEFAULT_SAVE_ADDRESS	((void *)0x8C000000)
#define SRAM_ADDR		((void *)0x90000000)
#define SRAM_SIZE		(128*1024-6) /* 6 is SRAM_*_PTR size */
#define SRAM_ADDRESS_PTR	((void **)((char *)SRAM_ADDR+SRAM_SIZE+2))
#define SRAM_CHECKSUM_PTR    ((unsigned short *)((char *)SRAM_ADDR+SRAM_SIZE))
#endif /* HAVE_SUB_SRAM */

/***** something... *****/
#define CHECK_GO_SWITCH()	0/* dummy */

/***** for serial code *****/
#define SERIAL_INTR_RESET()	(set_IMASK(SERIAL_INTR_LEVEL))
#define SET_SERIAL_RTS(flag)	(SCIF.SCSCR.BIT.RIE = (flag))
#define GET_SERIAL_CTS()	(1)
#define SEND(c)			do {			\
    volatile unsigned short dummy = SCIF.SCSSR.WORD;	\
    if ((dummy & 0x0020) == 0) { /*check TDFE*/		\
	SCIF.SCSSR.BIT.TDFE = 0;			\
	SCIF.SCSSR.BIT.TEND = 0;			\
	return;						\
    }							\
    SCIF.SCFTDR = (c);					\
    SCIF.SCSSR.BIT.TDFE = 0; SCIF.SCSSR.BIT.TEND = 0;	\
} while (0/*CONSTCOND*/)
#define SEND_START()		(SCIF.SCSCR.BIT.TIE = 1)
#define SEND_END()		(SCIF.SCSCR.BIT.TIE = 0)
#define RECV(c)			do {			\
    volatile unsigned short dummy = SCIF.SCSSR.WORD;	\
    if ((dummy & 0x0002) == 0) return;/*check RDF*/	\
    (c) = SCIF.SCFRDR;					\
    SCIF.SCSSR.BIT.DR  = 0;				\
    SCIF.SCSSR.BIT.RDF = 0;				\
} while (0/*CONSTCOND*/)
#define IS_ERROR()		(SCIF.SCSSR.WORD & 0x009C)
#define CLEAR_ERROR()		do {			\
    volatile unsigned short dummy = SCIF.SCSSR.WORD;	\
    SCIF.SCSSR.WORD &= ~0x009C;				\
} while (0/*CONSTCOND*/)

#endif /* __MACDEP_H__ */

