/* $Id: monitor.h,v 1.3 2002/01/13 02:31:59 amura Exp $ */
/*
 *  Copyright (c) 2001,2002    MURAMATSU Atsushi
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * A Simple Monitor Program Header
 *   - general header
 */

#ifndef __MONITOR_H__
#define __MONITOR_H__

#define S_NOFLOW	0
#define S_XONOFF	1
#define S_RTSCTS	2

#include "vector.h"

#ifndef MONITOR_IN

#define MONITOR_FUNC_TBL	((void **)0x0008000)

#define reset_handler_to_default ((void (*)(void))MONITOR_FUNC_TBL[0])
#define serial_init	((void (*)(void))	MONITOR_FUNC_TBL[1])
#define serial_mode	((void (*)(long, int))	MONITOR_FUNC_TBL[2])
#define s_putc		((void (*)(int))	MONITOR_FUNC_TBL[3])
#define s_puts		((void (*)(char *))	MONITOR_FUNC_TBL[4])
#define s_getc		((int  (*)(void))	MONITOR_FUNC_TBL[5])
#define s_getc_nowait	((int  (*)(void))	MONITOR_FUNC_TBL[6])
#define s_gets		((int  (*)(char *, int))MONITOR_FUNC_TBL[7])
#define s_gets_echo	((int  (*)(char *, int))MONITOR_FUNC_TBL[8])

#define DEFAULT_HANDLER_TBL	((void **)0x0009000)

#define dummy_handler	((void (*)(void))	DEFAULT_HANDLER_TBL[0])

#endif

#endif /* __MONITOR_H__ */
