/* $Id: monitor_in.h,v 1.3 2002/01/13 16:36:41 amura Exp $ */
/*
 *  Copyright (c) 2001,2002    MURAMATSU Atsushi
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * A Simple Monitor Program Header
 *   - monitor internal header
 */

#ifndef __MONITOR_IN_H__
#define __MONITOR_IN_H__

#define PROMPT	">> "

/***** Buffersize constants *****/
#define LINE_BUFFER_SIZE	128
#define LOAD_BUFFER_SIZE        LINE_BUFFER_SIZE
#define ARGS_MAX		4
#define FILENAME_LEN		12

#define S_SEND_BUFFER_SIZE	256
#define S_RECV_BUFFER_SIZE	256
#define S_RECV_BUFFER_WARN	(S_RECV_BUFFER_SIZE/3 * 2)
#define S_RECV_BUFFER_NORM	(S_RECV_BUFFER_SIZE/3)

#define DEFAULT_BIT_RATE	38400

/***** Normal constants *****/
#define ESC		0x1b
#define BACKSPACE	0x08
#define CRLF		"\r\n"
#define XON		0x11
#define XOFF		0x13

#define TRUE		1
#define FALSE		0

#define ON		1
#define OFF		0

/***** Function declearations *****/
void monitor_help(void);
void monitor_edit(char *addr_str);
void monitor_dump(char *addr_str, char *length_str);
void monitor_run(char *addr_str);
int  monitor_load(void);
void monitor_store(char *addr_str);
int  monitor_restore(void);

/***** default handlers *****/
void dummy_handler(void);

/***** initializer *****/
void set_handler_to_default(void);
void monitor_init(void);
void __serial_init(void);
void __serial_mode(long speed, int type);

/***** Serial funcitions for internal use *****/
void serial_init(void);
void serial_mode(long speed, int type);
void s_putc(int c);
void s_puts(const char *str);
int s_getc(void);
int s_getc_nowait(void);
int s_gets(char *str, int strsize);
int s_gets_echo(char *str, int strsize);
int s_gets_echo_with_go(char *str, int strsize);

/***** start address *****/
extern void FAR *start_addr;
extern char filename[];

#define MONITOR_IN	1	/* This is the flag */

#endif /* __MONITOR_IN_H__ */

