/* $Id: monitor_sh3.S,v 1.3 2002/01/13 16:36:41 amura Exp $ */
/*
 *  Copyright (c) 2001,2002    MURAMATSU Atsushi
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * A Simple Monitor Program Header
 *   - machine indepedent startup codes for HITACHI SH-3
 */
	
	.equ	SDMR,	0xFFFFE000	/* set SDRAM register */
	.equ	BSC,	0xFFFFFF60	/* bus state controller */
	.equ	CPG,	0xFFFFFF80	/* clock pulse generator */
	.equ	MMUCR,	0xFFFFFFE0	/* MMU control resigter */
	.equ	CCR,	0xFFFFFFEC	/* cache controll register */
	.equ	TRA,	0xFFFFFFD0	/* trap number */
	.equ	EXPEVT,	0xFFFFFFD4	/* exception event code */
	.equ	INTEVT,	0xFFFFFFD8	/* interrupt event code */
	.equ	INTEVT2,0xA4000000	/* interrupt event code 2 */

.section .startup
	.extern		_main,_go_addr
	.global		bootstrap,___main
	.global		default_ill_handler,default_intr_handler
	.global         _dummy_handler,_start

/********** start up **********/
		.org	0
bootstrap:
	/*
	 *  Bus State Controller Setup
	 */
		mov	#9,r0		/* r0 is move words counter */
		mov.l	k_bsc_data,r1	/* r1 is source data */
		mov.l	k_bsc_addr,r2	/* r2 is destination */
	_bsc_set_loop:
		mov.w	@r1+,r3		/* move.w (r1)+,r3 */
		mov.l	@r2+,r4		/* move.l (r2)+,r4 */
		mov.w	r3,@r4		/* move.l r3,(r4) */
		dt	r0		/* dbra r0,_bsc_set_loop */
		bf	_bsc_set_loop

		/* DRAM access wait */
		mov.l	k_BSC_RFCR,r1	/* move.w #$a400,(BSC_RFCR) */
		mov.w	imm_a400h,r0	/* disable intr, count limit 1024 */
		mov.w	r0,@r1
		mov	#30,r3
	_dram_wait_loop:
		mov.w	@r1,r0		/* cmp.w #30,(BSC_RFCR) */
		extu.w	r0,r2
		cmp/hi	r2,r3		/* blt _dram_wait_loop */
		bt	_dram_wait_loop

		mov.l	k_SDMR3,r0	/* move.w #0,(SDMR3) */
		mov	#0,r1
		mov.b	r1,@r0		/* SDRAM mode set */

	/*
	 * Clock Pulse Generator setup
	 */
		mov.l	k_CPG,r8
		mov.w	imm_a500h,r0
		mov.w	r0,@(6,r8)	/* (WTCSR) watch dog timer stop */
		or	#3,r0
		mov.w	r0,@(6,r8)	/* (WTCSR) set timer div(1/32) */
		mov.w	imm_5a80h,r0
		mov.w	r0,@(4,r8)	/* (WTCNT) WD counter set to 128 */
		mov.w	imm_0112h,r0
		mov.w	r0,@(0,r8)	/* (FRQCR) raito I:B:P=8:4:2 */

	/*
	 * MMU Controll Register setup
	 */
		mov.l	k_MMUCR,r8
		mov	#0,r0
		mov.l	r0,@r8
	
	/*
	 * Cache Controll Register setup
	 */
		mov.l	k_CCR,r8
		mov	#8,r0
		mov.l	r0,@r8		/* Cache all clear */
		mov	#3,r0
		mov.l	r0,@r8		/* Cache ON / WriteThough */
	
	/*
	 * stack set
	 */
		mov.l	k_stack,sp
		
	/*
	 * zero out bss
	 */
		mov.l	k_edata,r0
		mov.l	k_end,r1
		mov	#0,r2
	start_l:
		mov.l	r2,@r0
		add	#4,r0
		cmp/ge	r0,r1
		bt	start_l

	/*
	 * call the mainline
	 */
		mov.l	k_main,r0
		jsr	@r0
		nop
	never_end:		
		bra	never_end
		nop
		/* never return from main_k */

		.align 4
	k_stack:	.long	_stack	
	k_edata:	.long	_edata
	k_end:		.long	_end
	k_main:		.long	_main

	k_bsc_addr:	.long	bsc_addr
	bsc_addr:
	/* BCR1 */	.long	BSC + 0x00
	/* BCR2 */	.long	BSC + 0x02
	/* BCR3 */	.long	BSC + 0x1e
	/* WCR1 */	.long	BSC + 0x04
	/* WCR2 */	.long	BSC + 0x06
	/* MCR  */	.long	BSC + 0x08
	/* DCR  */	.long	BSC + 0x0a
	/* RTCOR */	.long	BSC + 0x12
	/* RTCSR */	.long	BSC + 0x0e

	k_BSC_RFCR:	.long	BSC + 0x14
	k_SDMR3:	.long	SDMR + (0x00000220 << 2)
	k_CPG:		.long	CPG
	k_CCR:		.long	CCR
	k_MMUCR:	.long	MMUCR
			
	k_bsc_data:	.long	bsc_data
	bsc_data:
	/* BCR1 */	.word	0x3008	/* set Area 3 to SDRAM */
	/* BCR2 */	.word	0x35f0	/* Bus width set CS5:8,CS4:8,CS3:32 */
	/* BCR3 */	.word	0x1010	/* CS2:DRAM (unused) */
	/* WCR1 */	.word	0x1551	/* Idle cycle all 1 */
	/* WCR2 */	.word	0xffdd	/* Wait 6 cycle, CAS assert=2cycle */
	/* MCR  */	.word	0x5124	/* RAS-CAS delay 2 cycle */
					/* Write PreChargeDelay  2cycle, */
	/* DCR  */	.word	0x4000	/* CS2:DRAM (unused) */
	/* RTCOR */	.word	0xa53e	/* 1 reflesh/32us  RTCOR=124 */
	/* RTCSR */	.word	0xa510	/* CKIO=32MHz, clock source=1/16 */

	imm_a400h:	.word	0xa400
	imm_a500h:	.word	0xa500
	imm_5a80h:	.word	0x5a80
	imm_0112h:	.word	0x0112
	
/********** __main (dummy) **********/
___main:
		rts
		nop

/********** normal trap handler **********/
		.org    0x100
default_ill_handler:
		mov.l   r0,@-sp		/* register push */
	        mov.l   r1,@-sp

		/* Event check */
		mov.l	k_EXPEVT,r0	/* move.l (EXPEVT),r0 */
		mov.l	imm_160h,r1	/* move.l #$160,r1 */
		mov.l	@r0,r0
		cmp/eq	r0,r1		/* cmp.l r0,r1 */
		bf/s	jump_function	/* bra jump_function */
		mov.l	imm_400h,r0	/* move.l #$400, r0 (delay slot) */
		mov.l	k_TRA,r1	/* move.l (TRA),r0 */
		mov.l	@r1,r0
	jump_function:
		mov.l	k_trap_vector,r1/* lea.l (trap_vector,r0),r0 */
		mov.l	@(r0,r1),r0

		mov.l	@sp+,r1
		jmp	@r0		/* jmp (r0) */
		mov.l	@sp+,r0		/* delay slot */

		.align 4
	imm_160h:	.long	0x160
	imm_400h:	.long	0x400
	k_EXPEVT:	.long	EXPEVT
	k_TRA:		.long	TRA
	k_trap_vector:	.long	_trap_vector + 0x80000000
			
/********** TLB miss handler **********/
	        .org    0x400
tlb_miss_handler:
_dummy_handler:
		rte
		nop
		.align 4
	
/********** interrupt handler **********/
	        .org    0x600
default_intr_handler:
	        mov.l   r0,@-sp		/* push register */
	        mov.l   r1,@-sp

		/* Event  check */
		mov.l	k_INTEVT2,r1	/* move.l (INTEVT2),r0 */
		mov.l	@r1,r0
		shlr2	r0		/* shr.l #3,r0 */
		shlr	r0		
		mov.l	k_intr_vector,r1/* lea.l (intr_vector,r0),r1 */
		mov.l	@(r0,r1),r0

		mov.l	@sp+,r1
		jmp	@r0		/* jmp (r0) */
		mov.l	@sp+,r0		/* delay slot */
		
		.align	4
	k_INTEVT2:	.long	INTEVT2
	k_intr_vector:	.long	_intr_vector + 0x80000000

/********** program starting function **********/
		.align	4
_start:
	        stc.l   ssr,@-sp	/* all register push */
	        stc.l   spc,@-sp
        
	        mov.l   r0,@-sp
	        mov.l   r1,@-sp
	        mov.l   r2,@-sp
	        mov.l   r3,@-sp
	        mov.l   r4,@-sp
	        mov.l   r5,@-sp
	        mov.l   r6,@-sp
	        mov.l   r7,@-sp
	        mov.l   r8,@-sp
	        mov.l   r9,@-sp
	        mov.l   r10,@-sp
	        mov.l   r11,@-sp
	        mov.l   r12,@-sp
	        mov.l   r13,@-sp
	        mov.l   r14,@-sp
	
	        stc     gbr,r0
	        mov.l   r0,@-sp
	        stc     vbr,r0
	        mov.l   r0,@-sp
	        sts     mach,r0
	        mov.l   r0,@-sp
	        sts     macl,r0
	        mov.l   r0,@-sp
	        sts     pr,r0
	        mov.l   r0,@-sp
	        
	        stc.l   r0_bank,@-sp
	        stc.l   r1_bank,@-sp
	        stc.l   r2_bank,@-sp
	        stc.l   r3_bank,@-sp
	        stc.l   r4_bank,@-sp
	        stc.l   r5_bank,@-sp
		stc.l   r6_bank,@-sp
	        stc.l   r7_bank,@-sp
        
		/* switch stack pointer */
		mov.l	k_old_sp,r1
		mov.l	sp,@r1
		mov.l	k_prog_stack,sp

		/* call the program */
		mov.l	k_go_addr,r0
		mov.l	@r0,r1
		jsr	@r1
		nop

		/* restore stack pointer */
		mov.l	k_old_sp,r1
		mov.l	@r1,sp

	        ldc.l   @sp+,r7_bank	/* all register pop */
	        ldc.l   @sp+,r6_bank
	        ldc.l   @sp+,r5_bank
	        ldc.l   @sp+,r4_bank
	        ldc.l   @sp+,r3_bank
	        ldc.l   @sp+,r2_bank
	        ldc.l   @sp+,r1_bank
	        ldc.l   @sp+,r0_bank

	        mov.l   @sp+,r0
	        lds     r0,pr
	        mov.l   @sp+,r0
	        lds     r0,macl
	        mov.l   @sp+,r0
	        lds     r0,mach
	        mov.l   @sp+,r0
	        ldc     r0,vbr
	        mov.l   @sp+,r0
	        ldc     r0,gbr
        
	        mov.l   @sp+,r14
	        mov.l   @sp+,r13
	        mov.l   @sp+,r12
	        mov.l   @sp+,r11
	        mov.l   @sp+,r10
	        mov.l   @sp+,r9
	        mov.l   @sp+,r8
	        mov.l   @sp+,r7
	        mov.l   @sp+,r6
	        mov.l   @sp+,r5
	        mov.l   @sp+,r4
	        mov.l   @sp+,r3
	        mov.l   @sp+,r2
	        mov.l   @sp+,r1
	        mov.l   @sp+,r0
	
	        ldc.l   @sp+,spc
	        ldc.l   @sp+,ssr
			
		rts
		nop

		.align	4
	k_go_addr:	.long	_go_addr
	k_old_sp:	.long	old_sp
	k_prog_stack:	.long	_prog_stack

.section .eram	/* This section is in the external SDRAM */
	.global _start_addr,_filename
	_start_addr:	.long	0
	_filename:	.byte	0

.section .estack
			.long	0xdeaddead	/* this data is dummy */

.section .vector
	.global _intr_vector,_trap_vector
			.org	0
	_intr_vector:	.skip	256*4
			.org	0x800
	_trap_vector:	.skip	257*4
	
.section .bss
	old_sp:		.long	0

.section .stack
			.skip	0x1000

	.end
